.include "m32def.inc"
.device ATMEGA32

.dseg


Count: .byte 4

buf1: .byte 8
buf2: .byte 8



.cseg
; die int vect tabelle anpassen an P!!!
; atmega32 = 4 byte int vectors!
reset:			rjmp _init         ; 1
            nop
int_ext0:		reti               ; 2
            nop
int_ext1:		reti	             ; 3 
            nop
int_ext2:		reti	             ; 4 
            nop
int_t2cmp:	reti             ; 5 
            nop
int_t2ovr:	reti             ; 6 
            nop
int_t1capt:	reti             ; 7 
            nop
int_t1cmpa:	reti             ; 8 
            nop
int_t1cmpb:	reti             ; 9 
            nop
int_t1ovr:	reti             ; 10 
            nop
int_t0cmp:	reti             ; 11 
            nop
int_t0ovr:	reti             ; 12 
            nop
int_spistc:	reti             ; 13 
            nop
int_usart_rxc:reti           ; 14
              nop
int_usart_udre:	reti           ; 15 
                nop
int_usart_txc:	reti           ; 16 
                nop
int_adc:		reti               ; 17 
            nop
int_eerdy:	reti             ; 18 
            nop
int_anacmp:	reti             ; 19 
            nop
int_twi:		rjmp _twi_isr ; reti  ; 20
            nop
int_spmrdy:	reti             ; 21
            nop


.include "twi_slave.inc"

_init:
; init stack
	ldi	r16,low(RAMEND)
	out	SPL,r16		; Set stack pointer to last internal RAM location
	ldi	r16,high(RAMEND)
	out	SPH,r16		; Set stack pointer to last internal RAM location


	ldi	r16, 0xff
	out	DDRA, r16		; alle pins in porta auf ausgang
	out DDRB, r16	
	out DDRD, r16	
  clr r16
  out PORTA, r16
  out PORTB, r16
  out PORTD, r16


  rcall ledtest

  ldi r16, 0
  sts buf1+0, r16
  sts buf2+0, r16
  sts buf1+1, r16
  sts buf2+1, r16
  sts buf1+2, r16
  sts buf2+2, r16
  sts buf1+3, r16
  sts buf2+3, r16
  
  ldi r16, HIGH(buf1)
  sts twi_txbuf+1, r16
  ldi r16, LOW(buf1)
  sts twi_txbuf+0, r16

  ldi r16, HIGH(buf2)
  sts twi_rxbuf+1, r16
  ldi r16, LOW(buf2)
  sts twi_rxbuf+0, r16

  ldi r16, 4
  sts twi_rxbuf_maxpos, r16
  sts twi_txbuf_maxpos, r16
  
  ldi r20, 0x40
  rcall Twi_init_slave                                         ; TWI aktivieren 


mainloop:
nop
  ldi r20, 255
  ldi r21, 5
  rcall _wait




  clr r0
  clr r1
  inc r1

cli
  lds r16, buf1+0
  lds r17, buf1+1
  lds r18, buf1+2
  lds r19, buf1+3

  add r16, r1
  adc r17, r0
  adc r18, r0
  adc r19, r0

  sts buf1+0, r16
  sts buf1+1, r17
  sts buf1+2, r18
  sts buf1+3, r19
  sts buf2+0, r16
  sts buf2+1, r17
  sts buf2+2, r18
  sts buf2+3, r19
sei




nop
nop
nop
    rjmp mainloop    



; Unterprogramme 


; wait loop 
; waitcycles: 3 + 4 + 1 + ( (3*r21 - 1) + 1 + 2 + 1) * r20 - 1
; = 7 + ( (3*r20 - 1) + 4) * r21
  
_wait:					; 3 cl for rcall
; input r21, r20
; uses  r31, r30
  mov r31, r21			; 1 cl
_w1:
  mov r30, r20			; 1 cl
_w2:
  dec r30				; 1 cl
  brne _w2				; 2 cl / 1 cl if no branch
  dec r31				; 1 cl
  brne _w1				; 2 cl / 1 cl if no branch
  ret	


wait1:
  ldi r20, 255
  ldi r21, 75
  rcall _wait
  ldi r20, 255
  ldi r21, 75
  rcall _wait
  ldi r20, 255
  ldi r21, 75
  rcall _wait
  ldi r20, 255
  ldi r21, 75
  rcall _wait
  ldi r20, 255
  ldi r21, 75
  rcall _wait
  ldi r20, 255
  ldi r21, 75
  rcall _wait
  ldi r20, 255
  ldi r21, 75
  rcall _wait
  ldi r20, 255
  ldi r21, 75
  rcall _wait




  ret


ledtest:
  sbi PORTA, 0
  rcall wait1  
  sbi PORTA, 1
  rcall wait1  
  sbi PORTA, 2
  rcall wait1  
  sbi PORTA, 3
  rcall wait1  
  sbi PORTA, 4
  rcall wait1  
  sbi PORTA, 5
  rcall wait1  
  sbi PORTA, 6
  rcall wait1  
  sbi PORTA, 7
  rcall wait1  

  sbi PORTB, 0
  rcall wait1  
  sbi PORTB, 1
  rcall wait1  
  sbi PORTB, 2
  rcall wait1  
  sbi PORTB, 3
  rcall wait1  
  sbi PORTB, 4
  rcall wait1  
  sbi PORTB, 5
  rcall wait1  
  sbi PORTB, 6
  rcall wait1  
  sbi PORTB, 7
  rcall wait1  

  sbi PORTD, 0
  rcall wait1  
  sbi PORTD, 1
  rcall wait1  
  sbi PORTD, 2
  rcall wait1  
  sbi PORTD, 3
  rcall wait1  
  sbi PORTD, 4
  rcall wait1  
  sbi PORTD, 5
  rcall wait1  
  sbi PORTD, 6
  rcall wait1  
  sbi PORTD, 7
  rcall wait1  


  cbi PORTA, 0
  rcall wait1  
  cbi PORTA, 1
  rcall wait1  
  cbi PORTA, 2
  rcall wait1  
  cbi PORTA, 3
  rcall wait1  
  cbi PORTA, 4
  rcall wait1  
  cbi PORTA, 5
  rcall wait1  
  cbi PORTA, 6
  rcall wait1  
  cbi PORTA, 7
  rcall wait1  

  cbi PORTB, 0
  rcall wait1  
  cbi PORTB, 1
  rcall wait1  
  cbi PORTB, 2
  rcall wait1  
  cbi PORTB, 3
  rcall wait1  
  cbi PORTB, 4
  rcall wait1  
  cbi PORTB, 5
  rcall wait1  
  cbi PORTB, 6
  rcall wait1  
  cbi PORTB, 7
  rcall wait1  

  cbi PORTD, 0
  rcall wait1  
  cbi PORTD, 1
  rcall wait1  
  cbi PORTD, 2
  rcall wait1  
  cbi PORTD, 3
  rcall wait1  
  cbi PORTD, 4
  rcall wait1  
  cbi PORTD, 5
  rcall wait1  
  cbi PORTD, 6
  rcall wait1  
  cbi PORTD, 7
  rcall wait1  

  ret
