; benutzt:
;   temporr: 
;     
;   dauerhaft: 


.dseg
twi_status: .byte 1
twi_error: .byte 1

twi_rxbuf:        .byte 2
twi_rxbuf_pos:    .byte 1
twi_rxbuf_maxpos: .byte 1
twi_txbuf:        .byte 2
twi_txbuf_pos:    .byte 1
twi_txbuf_maxpos: .byte 1

.cseg


twi_init_slave:
; in r20 = slave adresse
  ori r20, 1 ; general call zulassen
  out TWAR, r20  //Adresse setzen
  
  in r16, TWCR
  andi r16, 0b11001111
  ori r16, 0b01000101
  out TWCR, r16

	sei
  ret




//ACK nach empfangenen Daten senden/ ACK nach gesendeten Daten erwarten
;#define TWCR_ACK TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);  
; TWINT, TWEA, TWSTA, TWSTO, TWWC, TWEN, res, TWIE
.equ TWCR_ACK  = 0b11000101

//NACK nach empfangenen Daten senden/ NACK nach gesendeten Daten erwarten     
;#define TWCR_NACK TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
.equ TWCR_NACK = 0b10000101

//switched to the non adressed slave mode...
;#define TWCR_RESET TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);  
.equ TWCR_RESET = 0b11000101


; ISR, die bei einem Ereignis auf dem Bus ausgelst wird. Im Register TWSR befindet sich dann 
; ein Statuscode, anhand dessen die Situation festgestellt werden kann.

_twi_isr:
	push r16          ; temp auf dem Stack sichern            
	in r16, SREG      ; Einlesen des SREG 
	push r16          ; Schreiben von  SREG  im Stack (KOPIE)
	
	in r16, TWSR		; Status-Register abfragen						
	andi r16, 0xF8	

  out porta, r16

  cpi r16, 0x08 ; MT/MR: start erfolgreich
  breq TWI_ISR_start_ok
  cpi r16, 0x10 ; MT/MR: repeated start erfolgreich
  breq TWI_ISR_rep_start_ok
  cpi r16, 0x18 ; MT: SLA+W mit ACK besttigt
  breq TWI_ISR_MT_SLAW_ACK
  cpi r16, 0x20 ; MT: SLA+W mit NACK besttigt
  breq TWI_ISR_MT_SLAW_NACK
  cpi r16, 0x28 ; MT: Data gesendet, mit ACK besttigt
  breq TWI_ISR_MT_DATA_ACK
  cpi r16, 0x30 ; MT: Data gesendet, mit NACK besttigt
  breq TWI_ISR_MT_DATA_NACK
  cpi r16, 0x38 ; MT/MR: arbitration lost
  breq TWI_ISR_MTMR_ARB_LOST

  cpi r16, 0x40 ; MR: SLA+R gesendet und mit ACK besttigt
  breq TWI_ISR_MR_SLAR_ACK
  cpi r16, 0x48 ; MR: SLA+R gesendet und mit NACK besttigt
  breq TWI_ISR_MR_SLAR_NACK
  cpi r16, 0x50 ; MR: daten empfangen und mit ACK besttigt
  breq TWI_ISR_MR_DATA_ACK
  cpi r16, 0x58 ; MR: daten empfangen und mit NACK besttigt
  breq TWI_ISR_MR_DATA_NACK

  cpi r16, 0x60 ; SR: eigene SLA+W empfangen, mit ACK besttigt
  breq TWI_ISR_SR_SLAW_ACK
  cpi r16, 0x68 ; M/SR: arbitration lost, und eigene SLA+W empfangen und mit ACK besttigt
  breq TWI_ISR_SR_AL_SLAW_ACK
  cpi r16, 0x70 ; SR: general call+W empfangen, mit ACK besttigt
  breq TWI_ISR_SR_GCW_ACK
  cpi r16, 0x78 ; M/SR: arbitration lost, und general call+W empfangen und mit ACK besttigt
  breq TWI_ISR_SR_AL_GCW_ACK
  cpi r16, 0x80 ; SR: nach SLA+W daten empfangen und mit ACK besttigt
  breq TWI_ISR_SR_SLAW_DATA_ACK
  cpi r16, 0x88 ; SR: nach SLA+W daten empfangen und mit NACK besttigt
  breq TWI_ISR_SR_SLAW_DATA_NACK_
  cpi r16, 0x90 ; SR: nach general call+W daten empfangen und mit ACK besttigt
  breq TWI_ISR_SR_GCW_DATA_ACK
  cpi r16, 0x98 ; SR: nach general call+W daten empfangen und mit NACK besttigt
  breq TWI_ISR_SR_GCW_DATA_NACK_
  cpi r16, 0xA0 ; SR: stop condition oder repeated start (whrend noch addressiert)
  breq TWI_ISR_SR_STOP_OR_RESTART

  cpi r16, 0xA8 ; ST: eigene SLA+R empfangen, mit ACK besttigt
  breq TWI_ISR_ST_SLAR_ACK
  cpi r16, 0xB0 ; M/ST: arbitration lost, und eigene SLA+R empfangen und mit ACK besttigt
  breq TWI_ISR_ST_AL_SLAR_ACK
  cpi r16, 0xB8 ; ST: Daten gesendet und ACK empfangen
  breq TWI_ISR_ST_DATA_ACK
  cpi r16, 0xC0 ; ST: Daten gesendet und NACK empfangen
  breq TWI_ISR_ST_DATA_NACK_
  cpi r16, 0xC8 ; ST: (letzte) daten gesendet mit TWEA=0 und trotzdem ACK empfangen
  breq TWI_ISR_ST_LASTDATA_ACK_

  cpi r16, 0xF8 ; kein status
  breq TWI_ISR_NOSTATE_

  ;cpi r16, 0x00 ; busfehler
  ; alle restlichen als busfehler interpretieren
  rjmp TWI_ISR_BUSFEHLER 

TWI_ISR_SR_SLAW_DATA_NACK_: rjmp TWI_ISR_SR_SLAW_DATA_NACK
TWI_ISR_SR_GCW_DATA_NACK_: rjmp TWI_ISR_SR_GCW_DATA_NACK
TWI_ISR_ST_DATA_NACK_: rjmp TWI_ISR_ST_DATA_NACK
TWI_ISR_ST_LASTDATA_ACK_: rjmp TWI_ISR_ST_LASTDATA_ACK
TWI_ISR_NOSTATE_: rjmp TWI_ISR_NOSTATE

; alle MT und MR stati sollten nicht auftreten und werden ignoriert
TWI_ISR_start_ok: ; MT/MR: start erfolgreich
TWI_ISR_rep_start_ok: ; MT/MR: repeated start erfolgreich
TWI_ISR_MT_SLAW_ACK: ; MT: SLA+W mit ACK besttigt
TWI_ISR_MT_SLAW_NACK: ; MT: SLA+W mit NACK besttigt
TWI_ISR_MT_DATA_ACK: ; MT: Data gesendet, mit ACK besttigt
TWI_ISR_MT_DATA_NACK: ; MT: Data gesendet, mit NACK besttigt
TWI_ISR_MTMR_ARB_LOST: ; MT/MR: arbitration lost
TWI_ISR_MR_SLAR_ACK: ; MR: SLA+R gesendet und mit ACK besttigt
TWI_ISR_MR_SLAR_NACK: ; MR: SLA+R gesendet und mit NACK besttigt
TWI_ISR_MR_DATA_ACK: ; MR: daten empfangen und mit ACK besttigt
TWI_ISR_MR_DATA_NACK: ; MR: daten empfangen und mit NACK besttigt
	ldi r16, TWCR_RESET
  rjmp TWI_ISR_ENDE

TWI_ISR_SR_SLAW_ACK: ; SR: eigene SLA+W empfangen, mit ACK besttigt
TWI_ISR_SR_AL_SLAW_ACK: ; M/SR: arbitration lost, und eigene SLA+W empfangen und mit ACK besttigt
TWI_ISR_SR_GCW_ACK: ; SR: general call+W empfangen, mit ACK besttigt
TWI_ISR_SR_AL_GCW_ACK: ; M/SR: arbitration lost, und general call+W empfangen und mit ACK besttigt
	ldi r16, 0
  sts twi_rxbuf_pos, r16  
  
  ldi r16, TWCR_ACK; bereit zum empfang
  rjmp TWI_ISR_ENDE


TWI_ISR_SR_SLAW_DATA_ACK: ; SR: nach SLA+W daten empfangen und mit ACK besttigt
TWI_ISR_SR_GCW_DATA_ACK: ; SR: nach general call+W daten empfangen und mit ACK besttigt
  ; daten sichern
  push r17
  push r30
  push r31

  lds r16, twi_rxbuf_pos
  lds r17, twi_rxbuf_maxpos
  CP r16, r17
  brsh TWI_ISR_SR_DATA_ACK_buf_voll

  clr r17
  lds r30, twi_rxbuf+0
  lds r31, twi_rxbuf+1
  add r30, r16
  adc r31, r17
  inc r16
  sts twi_rxbuf_pos, r16
  in r17, TWDR
  ST Z, r17
  lds r17, twi_rxbuf_maxpos
  CP r16, r17
  brsh TWI_ISR_SR_DATA_ACK_buf_voll ; keine weiteren daten empfangbar, also mit NACK antworten
  
  ldi r16, TWCR_ACK ; weitere daten empfangbar
  rjmp TWI_ISR_SR_DATA_ACK_fin

TWI_ISR_SR_DATA_ACK_buf_voll:
  ldi r16, TWCR_NACK

TWI_ISR_SR_DATA_ACK_fin:
  pop r31
  pop r30
  pop r17

  ; und fertig
  rjmp TWI_ISR_ENDE



TWI_ISR_SR_STOP_OR_RESTART: ; SR: stop condition oder repeated start (whrend noch addressiert)
	ldi r16, TWCR_RESET
  rjmp TWI_ISR_ENDE


TWI_ISR_ST_SLAR_ACK: ; ST: eigene SLA+R empfangen, mit ACK besttigt
TWI_ISR_ST_AL_SLAR_ACK: ; M/ST: arbitration lost, und eigene SLA+R empfangen und mit ACK besttigt
	ldi r16, 0
  sts twi_txbuf_pos, r16  

TWI_ISR_ST_DATA_ACK: ; ST: Daten gesendet und ACK empfangen
  ; nchste daten holen und bermitteln
  push r17
  push r30
  push r31

  lds r16, twi_txbuf_pos
  lds r17, twi_txbuf_maxpos
  CP r16, r17
  brsh TWI_ISR_ST_DATA_ACK_buf_fertig

  clr r17
  lds r30, twi_txbuf+0
  lds r31, twi_txbuf+1
  add r30, r16
out portd, r30
  adc r31, r17

  inc r16
  sts twi_txbuf_pos, r16
  LD r17, Z
out portb, r17
  out TWDR, r17
  lds r17, twi_txbuf_maxpos
  CP r16, r17
  brsh TWI_ISR_ST_DATA_ACK_buf_fertig2 ; keine weiteren daten verfgbar, also mit NACK antworten
  
  ldi r16, TWCR_ACK ; weitere daten verfgbar
  rjmp TWI_ISR_ST_DATA_ACK_fin

TWI_ISR_ST_DATA_ACK_buf_fertig:
  ldi r16, 0
  out TWDR, r16 
TWI_ISR_ST_DATA_ACK_buf_fertig2:
  ldi r16, TWCR_NACK

TWI_ISR_ST_DATA_ACK_fin:
  pop r31
  pop r30
  pop r17

  ; und fertig  
  rjmp TWI_ISR_ENDE

 
TWI_ISR_ST_DATA_NACK: ; ST: Daten gesendet und NACK empfangen
TWI_ISR_ST_LASTDATA_ACK: ; ST: (letzte) daten gesendet mit TWEA=0 und trotzdem ACK empfangen
	ldi r16, TWCR_RESET
  rjmp TWI_ISR_ENDE ; alles fertig


TWI_ISR_SR_GCW_DATA_NACK: ; SR: nach general call+W daten empfangen und mit NACK besttigt
TWI_ISR_SR_SLAW_DATA_NACK: ; SR: nach SLA+W daten empfangen und mit NACK besttigt
  ; daten sichern
  push r17
  push r30
  push r31

  lds r16, twi_rxbuf_pos
  lds r17, twi_rxbuf_maxpos
  CP r16, r17
  brsh TWI_ISR_SR_DATA_NACK_buf_voll

  clr r17
  lds r30, twi_rxbuf+0
  lds r31, twi_rxbuf+1
  add r30, r16
  adc r31, r17
  inc r16
  sts twi_rxbuf_pos, r16
  in r17, TWDR
  ST Z, r17

TWI_ISR_SR_DATA_NACK_buf_voll:
  ldi r16, TWCR_NACK ; immer mit nack antworten, da master sowieso nix mehr schicken will

TWI_ISR_SR_DATA_NACK_fin:
  pop r31
  pop r30
  pop r17

  ; und fertig
  rjmp TWI_ISR_ENDE

TWI_ISR_NOSTATE: ; kein status
  rjmp TWI_ISR_EXIT; kein status, also auch nix tun ?


TWI_ISR_BUSFEHLER:
  ldi r16, TWCR_RESET

TWI_ISR_ENDE:
	out TWCR, r16

TWI_ISR_EXIT:
	pop	r16			  ; LESEN von SREG vom STACK (KOPIE)
	out	SREG, r16	; Wiederherstellen von SREG       
	pop r16
  reti   



